'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createLogicalExpression = createLogicalExpression;
exports.createAndExpression = createAndExpression;
exports.createOrExpression = createOrExpression;
exports.createNotExpression = createNotExpression;

var _types = require('./types');

var _types2 = _interopRequireDefault(_types);

var _getSurroundingLoc = require('ast-loc-utils/lib/getSurroundingLoc');

var _getSurroundingLoc2 = _interopRequireDefault(_getSurroundingLoc);

var _placeAtLoc = require('ast-loc-utils/lib/placeAtLoc');

var _placeAtLoc2 = _interopRequireDefault(_placeAtLoc);

var _placeAtNode = require('ast-loc-utils/lib/placeAtNode');

var _placeAtNode2 = _interopRequireDefault(_placeAtNode);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createLogicalExpression(operator) {
  for (var _len = arguments.length, conditions = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    conditions[_key - 1] = arguments[_key];
  }

  if (conditions.length === 1 && Array.isArray(conditions[0])) {
    conditions = conditions[0];
  }
  if (conditions.length === 0) {
    if (operator === "&&") return _types2.default.booleanLiteral(true);else return _types2.default.booleanLiteral(false);
  } else if (conditions.length === 1) {
    return conditions[0];
  } else {
    return (0, _placeAtLoc2.default)(_types2.default.logicalExpression(operator, conditions[0], createLogicalExpression(operator, conditions.slice(1))), (0, _getSurroundingLoc2.default)(conditions));
  }
}

function createAndExpression() {
  for (var _len2 = arguments.length, conditions = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
    conditions[_key2] = arguments[_key2];
  }

  if (conditions.length === 1 && Array.isArray(conditions[0])) {
    conditions = conditions[0];
  }return createLogicalExpression("&&", conditions);
}

function createOrExpression() {
  for (var _len3 = arguments.length, conditions = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
    conditions[_key3] = arguments[_key3];
  }

  if (conditions.length === 1 && Array.isArray(conditions[0])) {
    conditions = conditions[0];
  }return createLogicalExpression("||", conditions);
}

function createNotExpression(condition) {
  return (0, _placeAtNode2.default)(_types2.default.unaryExpression("!", condition), condition);
}